//+------------------------------------------------------------------+
//|                                                     BandsFBA.mq5 |
//|                                      Copyright  2010, Svinozavr |
//|                                                                  |
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2010, Svinozavr"
//----  
#property link      ""
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 6
//----    
#property indicator_plots   6
//+--------------------------------------------+
//|     BB  |
//+--------------------------------------------+
//----      
#property indicator_type1   DRAW_LINE
#property indicator_type2   DRAW_LINE
#property indicator_type3   DRAW_LINE
#property indicator_type4   DRAW_LINE
#property indicator_type5   DRAW_LINE
#property indicator_type6   DRAW_LINE
//----    
#property indicator_color1  clrPurple
#property indicator_color2  clrPurple
#property indicator_color3  clrPurple
#property indicator_color4  clrRed
#property indicator_color5  clrRed
#property indicator_color6  clrRed
//----   -  
#property indicator_style1 STYLE_DASHDOTDOT
#property indicator_style2 STYLE_DASHDOTDOT
#property indicator_style3 STYLE_DASHDOTDOT
//----   -  
#property indicator_style4 STYLE_SOLID
#property indicator_style5 STYLE_SOLID
#property indicator_style6 STYLE_SOLID
//----     1
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1
//+----------------------------------------------+
//|                     |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+

//----    CXMA  CStdDeviation   SmoothAlgorithms.mqh
CXMA XMA;
CStdDeviation STD;
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   //TrendFollow_2 Price 
  };
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input Smooth_Method bMA_Method=MODE_SMA; //  
input int bLength=20; //  BB                  
input int bPhase=15; //  ,
                     // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
input double BandsDeviation=2.0; // 
input Applied_price_ IPC=PRICE_CLOSE;// 
/* ,      ( 1-CLOSE, 2-OPEN, 3-HIGH, 4-LOW, 
  5-MEDIAN, 6-TYPICAL, 7-WEIGHTED, 8-SIMPL, 9-QUARTER, 10-TRENDFOLLOW, 11-0.5 * TRENDFOLLOW.) */

input uint FrontPeriod=1; //   ; .. <1
input uint BackPeriod=55; //   ; .. <1
input int BShift=0; //      
input int SShift=0; //       
//+----------------------------------------------+
//----   ,    
//      
double  XMAB[]; // XMA
double  TopB[]; //  
double  BotB[]; //  
double  XMAS[]; //  
double  TopS[]; //  
double  BotS[]; //  
//----     EMA
double per0,per1;
int FBA; // 1 -  , -1 -  , 0 -  MA -  !
//----      
int min_rates_,min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   string _fr=string(FrontPeriod);
   string _bk=string(BackPeriod);
   string _dv=string(BandsDeviation);
   string ShortName="BandsFBA";
   string _sg=_fr;
   FBA=0;

//----   
   if(FrontPeriod==BackPeriod)
     {
      FBA=0;
      per0=2.0/(1+FrontPeriod);
      per1=+1;
     }

   if(FrontPeriod<BackPeriod)
     {
      FBA=-1;
      per0=2.0/(1+FrontPeriod);
      per1=2.0/(1+BackPeriod);
     }
   else
     {
      FBA=+1;
      per0=2.0/(1+BackPeriod);
      per1=2.0/(1+FrontPeriod);
      _sg=_bk;
     }

//----     
   min_rates_=XMA.GetStartBars(bMA_Method,bLength,bPhase);
   min_rates_total=2*min_rates_+1;

//----      
   SetIndexBuffer(0,XMAB,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,BShift);
//----       1  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"XMA("+string(bLength)+")");

//----      
   SetIndexBuffer(1,TopB,INDICATOR_DATA);
//----    2    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,BShift);
//----       2  min_rates_total
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      DataWindow
   PlotIndexSetString(1,PLOT_LABEL,"TopB(+"+_dv+")");

//----      
   SetIndexBuffer(2,BotB,INDICATOR_DATA);
//----    2    Shift
   PlotIndexSetInteger(2,PLOT_SHIFT,BShift);
//----       3  min_rates_total
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      DataWindow
   PlotIndexSetString(2,PLOT_LABEL,"BotB(-"+_dv+")");

//----      
   SetIndexBuffer(3,XMAS,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(3,PLOT_SHIFT,SShift);
//----       4  min_rates_total
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      DataWindow
   PlotIndexSetString(3,PLOT_LABEL,"XMAS("+_sg+")");

//----      
   SetIndexBuffer(4,TopS,INDICATOR_DATA);
//----    2    Shift
   PlotIndexSetInteger(4,PLOT_SHIFT,SShift);
//----       4  min_rates_total
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      DataWindow
   PlotIndexSetString(4,PLOT_LABEL,"TopS("+_fr+","+_bk+")");

//----      
   SetIndexBuffer(5,BotS,INDICATOR_DATA);
//----    2    Shift
   PlotIndexSetInteger(5,PLOT_SHIFT,SShift);
//----       4  min_rates_total
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      DataWindow
   PlotIndexSetString(5,PLOT_LABEL,"BotS("+_fr+","+_bk+")");

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,ShortName);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(RESET);

//----    
   int first,bar,minbar;
   double price_,xmaa,stdeva,xmab,stdevb,stdevc;
   static double prev_stdevb,prev_stdevc,prev_xmab;

   minbar=min_rates_total-1;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0; //      
      prev_stdevb=1.0;
      prev_stdevc=1.0;
      prev_xmab=PriceSeries(IPC,first,open,low,high,close);
     }
   else first=prev_calculated-1; //      

//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      //----    
      price_=PriceSeries(IPC,bar,open,low,high,close);
      xmaa=XMA.XMASeries(0,prev_calculated,rates_total,bMA_Method,bPhase,bLength,price_,bar,false);
      XMAB[bar]=xmaa;

      //----      
      stdeva=STD.StdDevSeries(min_rates_,prev_calculated,rates_total,bLength,BandsDeviation,price_,xmaa,bar,false);
      TopB[bar]=xmaa+stdeva;
      BotB[bar]=xmaa-stdeva;

      if(bar<minbar) continue;
      else if(bar==minbar)
        {
         prev_stdevb=stdeva;
         prev_stdevc=stdeva;
         prev_xmab=price_;
        }

      xmab=EMA_FBA(xmaa,prev_xmab,per0,0);
      XMAS[bar]=xmab;

      stdevb=EMA_FBA(stdeva,prev_stdevb,per0,0);
      stdevc=EMA_FBA(stdevb,prev_stdevc,per1,FBA);

      TopS[bar]=xmab+stdevc;
      BotS[bar]=xmab-stdevc;

      if(bar<rates_total-1)
        {
         prev_stdevb=stdevb;
         prev_stdevc=stdevc;
         prev_xmab=xmab;
        }
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|  EMA FBA                                                   |
//+------------------------------------------------------------------+
/* 
 * EMA        
 * double Series      
 * double EMA1        EMA   
 * double period      ;  >1,    .EMA 
 * int FBA          +1 -  , 
 *                  -1 -  ,
 *                   0 -  EMA -  !
 */
//+------------------------------------------------------------------+
double EMA_FBA(double Series,double EMA1,double period,int fba)
  {
//----
   if(period==1) return(Series);

//---- . EMA 
   if(period>1) period=2.0/(1+period);

//---- EMA
   double EMA=period*Series+(1-period)*EMA1;

//----    
   switch(fba)
     {
      case  0: /*  MA */ return(EMA);
      case  1: /*   */ if(Series>EMA1) return(EMA); else return(Series);
      case -1: /*   */ if(Series<EMA1) return(EMA); else return(Series);
     }
//----
   return(EMA);
  }
//+------------------------------------------------------------------+
